<script setup>
import { computed, watch } from "vue";
import { i18n } from "@utils";
import { useStore } from "vuex";
import { VueFlow } from "@vue-flow/core";
import { Background } from "@vue-flow/background";
import { Controls } from "@vue-flow/controls";
import { MiniMap } from "@vue-flow/minimap";
import StateNode from "@/components/Level/StateNode.vue";
import ContextMenu from "@/components/Template/ContextMenu.vue";
import { useFlowSetup } from "@/composables/useFlowSetup";

const store = useStore();

const isLive = computed(() => store.state.live.isLive);

const {
  flow,
  stateNodes,
  showContextMenu,
  contextMenuPosition,
  contextMenuTarget,
  handleContextMenu,
  closeContextMenu,
  isNewLevelView,
} = useFlowSetup({
  store,
  onNodeSelect: (stateId) => store.dispatch("level/selectState", stateId),
  onNodePositionChange: ({ stateId, position }) => store.dispatch("level/updateStatePosition", { stateId, position }),
});

function onDrop(event) {
  const { left, top } = flow.vueFlowRef.value.getBoundingClientRect();
  const position = flow.project({ x: event.clientX - left - 100, y: event.clientY - top - 10 });
  const actionName = event.dataTransfer?.getData("action");
  const asset = event.dataTransfer?.getData("asset");
  const actionId = event.dataTransfer?.getData("actionId");
  const originState = event.dataTransfer?.getData("originState");

  if (actionName) {
    store.dispatch("level/addState", { actionName, position });
  }
  if (asset) {
    const message = i18n("ERROR.ASSET_ON_STAGE", { asset });
    store.dispatch("adaptor/addLog", { type: "error", message });
  }
  if (actionId) {
    store.dispatch("level/moveExistingActionToNewState", { originState, actionId, position });
  }
}

watch(isLive, () => (flow.nodesDraggable.value = !isLive.value));
watch([() => store.state.level.id], () => (isNewLevelView.value = true));
</script>

<template>
  <VueFlow :nodes="stateNodes" @drop="onDrop" @dragover.prevent>
    <template #node-adaptorState="{ id, data, selected, events }">
      <StateNode
        :state-name="id"
        :data="data"
        :selected="selected"
        :events="events"
        @contextmenu.stop="handleContextMenu($event, data.id)"
      />
    </template>
    <Background :pattern-color="'#aaa'" gap="15" />
    <MiniMap pannable />
    <Controls :show-interactive="!isLive" />

    <ContextMenu
      v-if="showContextMenu"
      :x="contextMenuPosition.x"
      :y="contextMenuPosition.y"
      :target="contextMenuTarget"
      @close="closeContextMenu"
    />
  </VueFlow>
</template>
